<?php
/**
 * XOOPS main configuration file
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting source code
 * which is considered copyrighted (c) material of the original comment or credit authors.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @copyright   The XOOPS Project http://sourceforge.net/projects/xoops/
 * @license     GNU GPL 2 (http://www.gnu.org/licenses/old-licenses/gpl-2.0.html)
 * @version     $Id: mainfile.dist.php 8066 2011-11-06 05:09:33Z beckmi $
 */

//自動取得網址
if(!function_exists('get_xoops_url')){
  function get_xoops_url(){
    $u=parse_url("http://".$_SERVER["HTTP_HOST"].$_SERVER['REQUEST_URI']);
    if(!empty($u['path']) and preg_match('/\/modules/',$u['path'])){
      $XMUrl=explode("/modules",$u['path']);
    }elseif(!empty($u['path']) and preg_match('/\/themes/',$u['path'])){
      $XMUrl=explode("/themes",$u['path']);
    }elseif(!empty($u['path']) and preg_match('/\/upgrade/',$u['path'])){
      $XMUrl=explode("/upgrade",$u['path']);
    }elseif(!empty($u['path']) and preg_match('/.php/',$u['path'])){
      $XMUrl[0]=dirname($u['path']);
    }elseif(!empty($u['path'])){
      $XMUrl[0]=$u['path'];
    }else{
      $XMUrl[0]="";
    }

    $my_url=str_replace('\\','/',$XMUrl['0']);
    if(substr($my_url,-1)=='/')$my_url=substr($my_url,0,-1);
    $url="{$u['scheme']}://{$u['host']}{$my_url}";
    return $url;
  }
}

//自動取得實體位置
if(!function_exists('get_xoops_path')){
  function get_xoops_path(){
    $SCRIPT_FILENAME=str_replace('\\','/',$_SERVER["SCRIPT_FILENAME"]);
    if(preg_match('/\/modules/',$SCRIPT_FILENAME)){
      $XMPath=explode("/modules",$SCRIPT_FILENAME);
      $root_path=$XMPath[0];
    }elseif(preg_match('/\/themes/',$SCRIPT_FILENAME)){
      $XMPath=explode("/themes",$SCRIPT_FILENAME);
      $root_path=$XMPath[0];
    }elseif(preg_match('/\/upgrade/',$SCRIPT_FILENAME)){
      $XMPath=explode("/upgrade",$SCRIPT_FILENAME);
      $root_path=$XMPath[0];
    }else{
      $root_path=dirname($SCRIPT_FILENAME);
    }
    return $root_path;
  }
}

$ip=get_xoops_url(); //可用ip或網址，改完請清除 /xoops_data/caches/smarty_compile 所有快取
$root_path=str_replace('\\','/',get_xoops_path());
$xoop_up_path=str_replace('\\','/',dirname($root_path));


if (!defined("XOOPS_MAINFILE_INCLUDED")) {
    define("XOOPS_MAINFILE_INCLUDED", 1);

    // XOOPS Physical Paths

    // Physical path to the XOOPS documents (served) directory WITHOUT trailing slash
    define('XOOPS_ROOT_PATH', "{$root_path}");

    // For forward compatibility
    // Physical path to the XOOPS library directory WITHOUT trailing slash
    define('XOOPS_PATH', "{$xoop_up_path}/xoops_lib");
    // Physical path to the XOOPS datafiles (writable) directory WITHOUT trailing slash
    define('XOOPS_VAR_PATH', "{$xoop_up_path}/xoops_data");
    // Alias of XOOPS_PATH, for compatibility, temporary solution
    define("XOOPS_TRUST_PATH", XOOPS_PATH);

    // URL Association for SSL and Protocol Compatibility
    $http = 'http://';
    if (!empty($_SERVER['HTTPS'])) {
        $http = ($_SERVER['HTTPS']=='on') ? 'https://' : 'http://';
    }
    define('XOOPS_PROT', $http);

    // XOOPS Virtual Path (URL)
    // Virtual path to your main XOOPS directory WITHOUT trailing slash
    // Example: define('XOOPS_URL', 'http://localhost');
    define('XOOPS_URL', "{$ip}");

/*
echo "<div>root_path:".$root_path."</div>";
echo "<div>xoop_up_path:".$xoop_up_path."</div>";
echo "<div>XOOPS_URL:".XOOPS_URL."</div>";
echo "<div>XOOPS_ROOT_PATH:".XOOPS_ROOT_PATH."</div>";
echo "<div>XOOPS_PATH:".XOOPS_TRUST_PATH."</div>";
echo "<div>XOOPS_VAR_PATH:".XOOPS_VAR_PATH."</div>";
echo "<div>XOOPS_TRUST_PATH:".XOOPS_TRUST_PATH."</div>";
echo "<div>\$_SERVER[PHP_SELF]:".$_SERVER['PHP_SELF']."</div>";
echo "<div>\$_SERVER[SCRIPT_FILENAME]:".$_SERVER["SCRIPT_FILENAME"]."</div>";
exit;
*/

    // Shall be handled later, don't forget!
    define("XOOPS_CHECK_PATH", 0);
    // Protect against external scripts execution if safe mode is not enabled
    if (XOOPS_CHECK_PATH && !@ini_get("safe_mode")) {
        if (function_exists("debug_backtrace")) {
            $xoopsScriptPath = debug_backtrace();
            if (!count($xoopsScriptPath)) {
                 die("XOOPS path check: this file cannot be requested directly");
            }
            $xoopsScriptPath = $xoopsScriptPath[0]["file"];
        } else {
            $xoopsScriptPath = isset($_SERVER["PATH_TRANSLATED"]) ? $_SERVER["PATH_TRANSLATED"] :  $_SERVER["SCRIPT_FILENAME"];
        }
        if (DIRECTORY_SEPARATOR != "/") {
            // IIS6 may double the \ chars
            $xoopsScriptPath = str_replace(strpos($xoopsScriptPath, "\\\\", 2) ? "\\\\" : DIRECTORY_SEPARATOR, "/", $xoopsScriptPath);
        }
        if (strcasecmp(substr($xoopsScriptPath, 0, strlen(XOOPS_ROOT_PATH)), str_replace(DIRECTORY_SEPARATOR, "/", XOOPS_ROOT_PATH))) {
             exit("XOOPS path check: Script is not inside XOOPS_ROOT_PATH and cannot run.");
        }
    }

    // Secure file
    require XOOPS_VAR_PATH . '/data/secure.php';

    define('XOOPS_GROUP_ADMIN', '1');
    define('XOOPS_GROUP_USERS', '2');
    define('XOOPS_GROUP_ANONYMOUS', '3');

    //校園版安裝檢測
    if(file_exists(XOOPS_VAR_PATH . '/data/install_chk.php')){
      include XOOPS_VAR_PATH . '/data/install_chk.php';
    }


    if (!isset($xoopsOption["nocommon"]) && XOOPS_ROOT_PATH != "") {
        include XOOPS_ROOT_PATH."/include/common.php";
    }

}

?>